/* $Id: Harp.java,v 1.6 2010/09/25 07:11:41 mit Exp $ */
/* Harp.java */
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.text.DecimalFormat;

public class Harp extends Applet implements AdjustmentListener 
{
    private Scrollbar scrX;
    final int L = 40; // Ĺ
    int W;
    int H;
    int Spoint;
    DecimalFormat df1;

    public void init() {
	setFont(new Font("SansSerif", Font.PLAIN, 12));
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
        df1 = new DecimalFormat("#0.0#");

        Panel p = new Panel();
        p.setLayout(new GridLayout(1,2,0,0));

        scrX = new Scrollbar(Scrollbar.HORIZONTAL,L/2,1,1,L);
	p.add(scrX);
	scrX.addAdjustmentListener(this);

        p.add(new Label(" : Striking Point"));

        add(p, "South");
    }
    public void start() {
	W = getSize().width;
	H = getSize().height;
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public void adjustmentValueChanged(AdjustmentEvent e) {
	repaint();
    }
 
    public void update(Graphics g) {
        paint(g);
    }    
    public void paint (Graphics g) {
	int M = 20;                // ܲ
	int y = 1;
	int dh = 5*H;
	int hh = H*2/3;
	double dx = (double)W/L;
	double[] Sum = new double[L+1];

	Spoint = scrX.getValue();  // Ǹ

	g.setColor(Color.black);
	g.fillRect(0, 0, W, H);

	g.setColor(Color.red);
	g.drawString("Striking Point: 1/"+
		     dform(1.0/(Spoint/(double)L)), 10, 15);

	double y0, y1, x0, x1 = 0;
	g.setColor(Color.magenta);
	for (int i = 1; i <= M; i++) {
	    y0 = hh-dh*yyh(i, 0); // z
	    for (int x = 0; x <= L; x++) {
		x0 = dx*x;
		y1 = yyh(i, x); // z
		if (x == 0) {
		    y0 = y1;
		    x1 = x0;
		    continue;
		}
		Sum[x] += y1;
		g.drawLine((int)x1, (int)(hh-dh*y0), (int)x0, (int)(hh-dh*y1));
		y0 = y1;
		x1 = x0;
	    }
	}

	double h0, v0, h1 = 0, v1 = 0;
	g.setColor(Color.green);
	for (int j = 0; j <= L; j++) {
	    h0 = dx*j;
	    v0 = hh-dh*Sum[j];
	    if (j == 0) {
		h1 = h0;
		v1 = v0;
		continue;
	    }
	    g.drawLine((int)h1, (int)v1, (int)h0, (int)v0);
	    h1 = h0;
	    v1 = v0;
	}
    }

    public double yyh(int m, int x) {
	double mp = m*Math.PI;
	return (1/Math.pow(mp, 2)* 
		Math.sin(mp*((double)x/L))* 
		Math.sin(mp*((double)Spoint/L)));
    }           // "cos mt"ϻִؿ(?)ΰپά
}
